endingIndex <- back

if(first )
{
pr.OHLC <- function(o, h, l, c){
price <- cbind(Open = rev(o), High = rev(h), Low = rev(l), Close = rev(c))
Med <- (price[ ,2] + price[ ,3])/2
CO <- price[ ,4] - price[ ,1]
price <- cbind(price, Med, CO)}

first = F
}

price <- pr.OHLC(Open, High, Low, Close)
rm(list = c("Open","High","Low","Close"))

mainData <- price[1:endingIndex ,'Close']
mainData <- as.data.frame(mainData, row.names = NULL)
mainData <- rename(mainData,c('mainData'='data'))

Sm <- mainData
Sm_pred <- c()

#These are the fractal dimension calculation parameters
#see the fractaldim library reference for more info

method <- "rodogram"

delta <- c()

# calculate delta between consecutive Sm values to use as guesses
for(j in 2:length(Sm$data)){
  delta <- rbind(delta, (Sm$data[j]-Sm$data[j-1])/Sm$data[j-1])
}

Sm_guesses <- delta

#do predictions of next values in Sm
for(i in 1:forward_pred){
  
  #update fractal dimension used as reference
  V_Reference <- fd.estimate(Sm$data, method=method)$fd
 
  minDifference = 1000000
  
  # check the fractal dimension of Sm plus each different guess and
  # choose the value with the least difference with the reference
  for(j in 1:length(Sm_guesses)){
    
      new_Sm <- rbind(Sm, Sm_guesses[j]*Sm$data[length(Sm$data)]+Sm$data[length(Sm$data)])
      new_V_Reference <- fd.estimate(new_Sm$data, method=method)$fd
    
      if (abs(new_V_Reference - V_Reference) < minDifference ){      
        Sm_prediction <- Sm$data[length(Sm$data)]+Sm_guesses[j]*Sm$data[length(Sm$data)]
        minDifference = abs(new_V_Reference - V_Reference)
      }
  }

  #add prediction to Sm
  Sm <- rbind(Sm, Sm_prediction)
}

n <- dim(Sm)[1]
Sm <- Sm[(endingIndex+1):n,]
Sm <- as.data.frame(Sm, row.names = NULL)
Sm <- rename(Sm,c('Sm'='data'))